/******************************** LICENSE ********************************


 Copyright 2007 European Centre for Medium-Range Weather Forecasts (ECMWF)
 
 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License.


 ******************************** LICENSE ********************************/

/*!
    \file OpenGLBaseTool.h
    \brief Definition of OpenGLBaseTool
    \author Graphics Section, ECMWF

    Started: May 2004
*/

#ifndef OpenGLBaseTool_H
#define OpenGLBaseTool_H

#include <OpenGLCommon.h>

class MtInputEvent;

namespace magics {

class OpenGLBaseTool 
{
public:
	OpenGLBaseTool() {};	
	
	virtual void enterMode(InteractiveMode) {};	
	virtual void leaveMode() {};	
	virtual void event(MtInputEvent*) {};
	virtual bool active() {};
	virtual void map(bool) {};
	virtual bool selected() {};
	virtual void currentFrameChanged(){};
};	

}

#endif
